//Вызов расчетной функции
function [rezult..//Результат расчета
          ]=CountFunction(inputDatas,..//Входные данные
                          inputDatasHeaders,..//Заголовки входных данных
                          Function,..//Функция
                          argumentsNames,..//Имена (индексы) аргументов
                          isVectorized..//Векторизована ли функция
                          )
    //Проверяем аргументы
    nArg = argn(2);//Число аргументов
    if nArg < 2 then
        error('Function CountRezult takes 2, 3, 4 or 5 arguments');
    end
    switch nArg
    case 2 then
        Function = inputDatasHeaders;
        inputDatasHeaders = [];
        argumentsNames = [];
        isVectorized = %t;//По умолчанию функция векторизована
    case 3 then
        if type(Function) == 4 then
            isVectorized = Function;
            argumentsNames = [];
        else
            argumentsNames = Function;
            isVectorized = %t;//По умолчанию функция векторизована
        end
        Function = inputDatasHeaders;
        inputDatasHeaders = [];
    case 4 then
        if type(argumentsNames) == 4 then
            isVectorized = argumentsNames;
            argumentsNames = Function;
            Function = inputDatasHeaders;
            inputDatasHeaders = [];
        else
            isVectorized = %t;//По умолчанию функция векторизована
        end
    end
    
    //Проверяем корректность аргументов
    if ~IsTableDatas(inputDatas) then
        error('The argument inputDatas of function CountFunction must be matrix of real, string, boolean');
    end
    if isempty(inputDatasHeaders) then
        if (~isempty(argumentsNames)) &&..
           ((type(argumentsNames) ~= 1) || (size(argumentsNames)(1) ~= 1)) then
            error('The argumentsNames argument of function CountFunction must be matrix 1xM of integer indexes');
        end
    else
        if type(inputDatasHeaders) ~= 10 then
            error('The inputDatasHeaders argument of function CountFunction must be matrix 1xM of string');
        end
        if (~isempty(argumentsNames)) &&..
           ((type(argumentsNames) ~= 10) || (size(argumentsNames)(1) ~= 1)) then
            error('The argumentsNames argument of function CountFunction must be matrix 1xM of string');
        end
    end
    if (type(isVectorized) ~= 4) || (size(isVectorized,'*') ~= 1) then
        error('The argument isVectorized of function CountFunction must be scalar boolean');
    end
    if (~IsTableDatasAndHeaders(inputDatas,inputDatasHeaders)) then
        error('The numbers of columns of arguments inputDatasHeaders and inputDatas of functions CountRezults must be equality');
    end
    select type(Function)
    case 10 then
        if size(Function,'*') > 1 then
            error('The argument Function of function CountFunction must be function or function''s name (scalar string)');
        else
            execstr('CallFunction = ' + Function);//Выполняем строку вызова функции
        end
    case 15 then
        //Формируем список параметров
        parametrs = Function;
        parametrs(1) = null();
        
        //Вызываемая функция
        select type(Function(1))
        case 10 then
            execstr('callFunction = ' + Function(1));
        case 13 then
            callFunction = Function(1);
        else
            error('The first element of list function and its parametrs must be function type and function name string type');
        end
        function rezult = CallFunction(arguments)//Создаем вызывную функцию
            rezult = callFunction(arguments,parametrs(:));//Вызываем функцию с параметрами
        endfunction
    case 13 then
        CallFunction = Function;
    else
        error('The argument Function of function CountFunction must be function type or function name string type');
    end
    
    //Выбираем аргументы для подстановки в функцию
    if isempty(argumentsNames) then
        Arguments = inputDatas;
    else
        Arguments = SelectionDatas(inputDatasHeaders,..
                                   argumentsNames,..
                                   inputDatas);
    end
                               
    //Вызываем функцию для аргументов
    if isVectorized then
        rezult = CallFunction(Arguments);
    else
        rezult = [];
        nArguments = NDatas(Arguments);//Число аргусентов
        for indArg=1:nArguments
            rezult = [rezult;..
                      CallFunction(SelectionDatasSubset(Arguments,indArg))];
        end
    end
endfunction
