//Разделение данных на входные и выходные данные
function [Datas..//Оставшиеся данные
          ]=EraseDatasSubset(Datas,..//Исходные данные
                             eraseDatasIndexes..//Индексы выделяемых совокупностей данных
                             )
    //Проверяем входные данные
    nArg = argn(2);//Число аргументов
    if nArg < 2 then
        error('Function EraseDatasSubset takes 2 arguments');
    end
    
    //Проверяем корректность введенных аргументов
    if (type(eraseDatasIndexes) ~= 1) &&..
       (type(eraseDatasIndexes) ~= 4) then
        error('The eraseDatasIndexes argument of function EraseDatasSubset must be matrix of integer or boolean');
    end
    if ~IsTableDatas(Datas) then
        error('The argument Datas of function EraseDatasSubset must be matrix of real, boolean or string');
    end
    
    //Удаляем данные
    if (type(eraseDatasIndexes) == 4) &&..
       (size(eraseDatasIndexes)(1) > 1) &&..
       (size(eraseDatasIndexes)(2) > 1) then
        eraseDatasIndexes = or(eraseDatasIndexes,'c'); 
    end
    Datas(eraseDatasIndexes,:) = [];
endfunction
