//Разделение данных на входные и выходные данные
function [isCountFunction,..//Факт того, что данные - расчетная функция (с параметрами или без)
          hasParametrs..//Факт того, что расчетная функция имеет параметры
          ]=IsCountFunction(Function..//Функция, для которой нужно установить факт того, что она расчетная функция
                            )
    //Проверяем входные данные
    [nRez,nArg] = argn();
    if nArg < 1 then
        error('The function IsCountFunction takes 1 argument');
    end
    
    //Устанавливаем файт того, является ли функция расчетной функцией
    if nRez > 1 then
        hasParametrs = HasParametrs(Function);//Факт того, что функция имеет параметры (заданы значения параметров)
        isCountFunction = hasParametrs || IsFunction(Function);
    else
        isCountFunction = IsFunction(Function) || HasParametrs(Function);
    end
endfunction

//Проверка наличия параметров у функции
function [hasParametrs]=HasParametrs(Function)
    hasParametrs = (type(Function) == 15) && (type(Function(1)) == 13);
endfunction

//Проверка того, что функция - это функция
function [isFunction]=IsFunction(Function)
    isFunction = (type(Function) == 13);
endfunction
