//Разделение данных на входные и выходные данные
function [isTableDatas,..//Факт того, что данные - табличные данные
          typeTableDatas..//Тип анализируемых табличных данных (0 - пустые данные, 1 - вещественные числа, 2 - логические значения (true/false), 3 - строки, -1 - данные не табличные)
          ]=IsTableDatas(Datas..//Данные, для которых нужно установить факт того, что они табличные данные
                         )
    //Проверяем входные данные
    [nRez,nArg] = argn();//Число результатов и аргументов соответственно
    if nArg < 1 then
        error('The function IsTableDatas takes 1 argument');
    end
    
    //Устанавливаем файт того, являются ли данные табличными данными или нет
    typesTableDatas = [1, 4, 10];//Допустимые типы табличных данных
    typeTableDatas = type(Datas);//Тип анализируемых данных
    isEmptyDatas = isempty(Datas);//Являются ли данные пустыми
    isTableDatas = (isEmptyDatas && (typeTableDatas == 1) || or(typeTableDatas == typesTableDatas));
    
    //Устанавливаем окончательно тип табличных данных
    if nRez > 1 then
        if isTableDatas then
            if isEmptyDatas then
                typeTableDatas = 0;//Данных нет совсем
            else
                typeTableDatas = find(typeTableDatas == typesTableDatas);//Получаем индекс табличных данных
            end
        else
            typeTableDatas = -1;//Данные не табличные
        end
    end
endfunction
