//Разделение данных на входные и выходные данные
function [isTableDatasAndHeaders,..//Факт того, что данные и заголовок - табличные данные и заголовок
          isEmptyTableDatasHeaders,..//Факт того, что заголовок табличных данных пустой
          isEmptyTableDatas..//Факт того, что табличные данные пустые
          ]=IsTableDatasAndHeaders(Datas,..//Данные
                                   DatasHeaders..//Заголовки данных
                                   )
    //Проверяем входные данные
    nArg = argn(2);//Число аргументов
    if nArg < 2 then
        error('The function IsTableDatasAndHeaders takes 2 arguments');
    end
    
    //Устанавливаем факт того, что данные являются табличными данными и заголовком
    isEmptyTableDatas = isempty(Datas);
    isEmptyTableDatasHeaders = isempty(DatasHeaders);
    [isTableDatasAndHeadersNoEmpty,..//Факт того, что данные и заголовок - табличные данные и заголовок не пустые
     isTableDatasHeaders..//Заголовок данных
     ]=IsTableDatasAndHeadersNoEmpty(Datas, DatasHeaders);
    isTableDatasAndHeaders = isEmptyTableDatasHeaders || isTableDatasHeaders &&..
                             (isEmptyTableDatas || isTableDatasAndHeadersNoEmpty);
endfunction
