//Разделение данных на входные и выходные данные
function [isTableDatasAndHeadersNoEmpty,..//Факт того, что данные и заголовок - табличные данные и заголовок не пустые
          isTableDatasHeaders..//Заголовок данных
          ]=IsTableDatasAndHeadersNoEmpty(Datas,..//Данные
                                          DatasHeaders..//Заголовки данных
                                          )
    //Проверяем входные данные
    nArg = argn(2);//Число аргументов
    if nArg < 2 then
        error('The function IsTableDatasAndHeaders takes 2 arguments');
    end
    
    //Устанавливаем факт того, что данные являются табличными данными и заголовком
    [nStrDatasHeaders,nStDatasHeaders] = size(DatasHeaders);//Число строк и столбцов в массиве заголовков данных
    isTableDatasHeaders = (nStrDatasHeaders == 1);//Заголовок данных - заголовок табличных данных или нет?
    isTableDatasAndHeadersNoEmpty = isTableDatasHeaders &&..
                                    (nStDatasHeaders == DatasDimension(Datas));
endfunction
