//Разделение данных на входные и выходные данные
function [selectionDatas,..//Выделенные данные
          selectionDatasHeader..//Заголовок выделенных данных
          ]=SelectionAllDatasExcept(Header,..//Заголовок таблицы данных (еще не разделенных)
                                    selectionExceptDatasHeader,..//Заголовок выделенных данных
                                    Datas..//Данные (отдельно от заголовка, не разделенные)
                                    )
    //Проверяем входные данные
    nArg = argn(2);//Число аргументов
    if nArg < 2 then
        error('Function SelectionAllDatasExcept takes 2 or 3 arguments');
    elseif nArg == 2 then
        Datas = selectionExceptDatasHeader;
        selectionExceptDatasHeader = Header;
        Header = [];
    end
    
    //Проверяем корректность аргументов
    if isempty(Header) then
        Header = 1:(size(Datas)(2));//Задаем индексы по умолчанию
    end
    if (type(Header) ~= 1) && (type(Header) ~= 10) then
        error('The Header argument of function SelectionAllDatasExcept must be matrix of string or integer');
    end
    if (~isempty(selectionExceptDatasHeader)) && ..
       (type(Header) ~= type(selectionExceptDatasHeader)) then
        error('The argument''s Header and selectionExceptDatasHeader of function SelectionAllDatasExcept types must be equality');
    end
    if ~IsTableDatas(Datas) then
        error('The argument Datas of function SelectionAllDatasExcept must be matrix of real, boolean or string');
    end
    if (~IsTableDatasAndHeaders(Datas,Header)) then
        error('The numbers of columns of arguments Header and Datas of functions SelectionAllDatasExcept must be equality');
    end
    
    //Получаем индексы выделенных данных
    selectionDataIndexes = (members(Header,selectionExceptDatasHeader) == 0);//Получаем индексы остающихся данных и их заголовков
    selectionDatasHeader = Header(selectionDataIndexes);//Заголовки данных, не входящих в исключаемые данные
    selectionDatas = Datas(:,selectionDataIndexes);//Данные, не соответсвующие исключаемым заголовкам
endfunction
