//Разделение данных на входные и выходные данные
function [selectionDatas,..//Выделенные данные
          selectionDatasHeader..//Заголовок выделенных данных
          ]=SelectionDatas(Header,..//Заголовок таблицы данных (еще не разделенных)
                           selectionDatasHeader,..//Заголовок выделенных данных
                           Datas..//Данные (отдельно от заголовка, не разделенные)
                           )
    //Проверяем входные данные
    nArg = argn(2);//Число аргументов
    if nArg < 2 then
        error('Function SelectionDatas takes 2 or 3 arguments');
    elseif nArg == 2 then
        Datas = selectionDatasHeader;
        selectionDatasHeader = Header;
        Header = [];
    end
    
    //Проверяем корректность аргументов
    if isempty(Header) then
        if type(selectionDatasHeader) ~= 1 then
            error('The selectionDatasHeader argument of function SelectionDatas must be matrix of integer');
        end
    else
        if type(Header) ~= 10 then
            error('The Header argument of function SelectionDatas must be matrix of string');
        end
        if (~isempty(selectionDatasHeader)) &&..
           (type(selectionDatasHeader) ~= 10) then
            error('The selectionDatasHeader argument of function SelectionDatas must be matrix of string');
        end
    end
    if ~IsTableDatas(Datas) then
        error('The argument Datas of function SelectionDatas must be matrix of real, boolean or string');
    end
    if (~IsTableDatasAndHeaders(Datas,Header)) then
        error('The numbers of columns of arguments Header and Datas of functions SelectionDatas must be equality');
    end
    
    //Получаем индексы выделенных данных
    if isempty(Header) then
        maxDataIndex = size(Datas)(2);//Максимальный индекс данных
        selectionDatasHeader(selectionDatasHeader > maxDataIndex) = [];//Удаляем индексы несуществующих данных
        selectionDataIndexes = selectionDatasHeader;//Индексы данных
    else
        [nData,selectionDataIndexes] = members(selectionDatasHeader,Header);//Получаем индексы
        clear nData;//Чистим память
        selectionDatasHeader(selectionDataIndexes == 0) = [];//Удаляем заголовки несуществующих данных
        selectionDataIndexes(selectionDataIndexes == 0) = [];//Удаляем индексы несуществующих данных
    end
    
    //Получаем выделенные данные
    selectionDatas = Datas(:,selectionDataIndexes);
endfunction
