//Данные для тестирования
DatasHeaders = ['Ae1','By1','Ag2','Cw3','Yey2','Aa2','Ab3','Cq1','Cq5'];//Заголовки данных
Datas = rand(45, 9);//Данные
AddingDatasHeaders = ['Cw3','Cq1','Ag2','Rew','Yey2','Uyt','Req2','Pou','Ab3','tre','Cq5'];//Заголовки добавляемых данных
AddingDatas = rand(45, 11);//Добавляемые данные

//Данные для проверки результата добавления
eDatasHeaders = [DatasHeaders,['Rew','Uyt','Req2','Pou','tre']];
eDatas = [Datas,AddingDatas(:,[4,6,7,8,10])];

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas(Datas,..//Данные (исходные, к которым добавляем данные)
            AddingDatas,..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c",..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            %f..//Замена значений величины новыми (в случае пересечения столбцов)
            );

//Проверяем результат
assert_checkequal(type(cDatas),1);//Проверяем тип данных
assert_checktrue(abs(cDatas - eDatas) < 1E-12);
assert_checkequal(cDatasHeaders,eDatasHeaders);

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas(Datas,..//Данные (исходные, к которым добавляем данные)
            AddingDatas,..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c"..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            );

//Проверяем результат
assert_checkequal(type(cDatas),1);//Проверяем тип данных
assert_checktrue(abs(cDatas - eDatas) < 1E-12);
assert_checkequal(cDatasHeaders,eDatasHeaders);

//Проверяем конкатенацию данных с приведением типов к строке

//Приводим данные к строке
sDatas = string(Datas);
sAddingDatas = string(AddingDatas);
seDatas = string(eDatas);

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas(sDatas,..//Данные (исходные, к которым добавляем данные)
            AddingDatas,..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c",..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            %f..//Замена значений величины новыми (в случае пересечения столбцов)
            );

//Проверяем результат
assert_checkequal(type(cDatas),10);//Проверяем тип данных
assert_checkequal(cDatas,seDatas);
assert_checkequal(cDatasHeaders,eDatasHeaders);

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas(sDatas,..//Данные (исходные, к которым добавляем данные)
            AddingDatas,..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c"..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            );

//Проверяем результат
assert_checkequal(type(cDatas),10);//Проверяем тип данных
assert_checkequal(cDatas,seDatas);
assert_checkequal(cDatasHeaders,eDatasHeaders);

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas(Datas,..//Данные (исходные, к которым добавляем данные)
            sAddingDatas,..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c",..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            %f..//Замена значений величины новыми (в случае пересечения столбцов)
            );

//Проверяем результат
assert_checkequal(type(cDatas),10);//Проверяем тип данных
assert_checkequal(cDatas,seDatas);
assert_checkequal(cDatasHeaders,eDatasHeaders);

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas(Datas,..//Данные (исходные, к которым добавляем данные)
            sAddingDatas,..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c"..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            );

//Проверяем результат
assert_checkequal(type(cDatas),10);//Проверяем тип данных
assert_checkequal(cDatas,seDatas);
assert_checkequal(cDatasHeaders,eDatasHeaders);

//Проверяем конкатенацию с пустым множеством

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas([],..//Данные (исходные, к которым добавляем данные)
            AddingDatas,..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c",..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            %f..//Замена значений величины новыми (в случае пересечения столбцов)
            );

//Проверяем результат
assert_checkequal(type(cDatas),1);//Проверяем тип данных
assert_checktrue(abs(cDatas - AddingDatas) < 1E-12);
assert_checkequal(cDatasHeaders,AddingDatasHeaders);

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas([],..//Данные (исходные, к которым добавляем данные)
            AddingDatas,..//Добавляем данные
            [],..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c"..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            );

//Проверяем результат
assert_checkequal(type(cDatas),1);//Проверяем тип данных
assert_checktrue(abs(cDatas - AddingDatas) < 1E-12);
assert_checkequal(cDatasHeaders,AddingDatasHeaders);

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas(Datas,..//Данные (исходные, к которым добавляем данные)
            [],..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c",..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            %f..//Замена значений величины новыми (в случае пересечения столбцов)
            );

//Проверяем результат
assert_checkequal(type(cDatas),1);//Проверяем тип данных
assert_checktrue(abs(cDatas - Datas) < 1E-12);
assert_checkequal(cDatasHeaders,DatasHeaders);

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas(Datas,..//Данные (исходные, к которым добавляем данные)
            [],..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            [],..//Заголовки добавляемых данных
            "c"..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            );

//Проверяем результат
assert_checkequal(type(cDatas),1);//Проверяем тип данных
assert_checktrue(abs(cDatas - Datas) < 1E-12);
assert_checkequal(cDatasHeaders,DatasHeaders);

clear;
