//Данные для тестирования
DatasHeaders = ['A1','T1','A2','D3','B2'];//Заголовки данных
Datas = rand(9, 5);//Данные
AddingDatasHeaders = ['D3','B2','A1','A2','T1'];//Заголовки добавляемых данных
AddingDatas = rand(1, 5);//Добавляемые данные

//Данные для проверки результата добавления
eDatasHeaders = DatasHeaders;
eAddingDatas = repmat(AddingDatas',[1, 9])';
eDatas = Datas; eDatas = eAddingDatas(:,[3,5,4,1,2]);

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas(Datas,..//Данные (исходные, к которым добавляем данные)
            AddingDatas,..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c",..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            %t..//Замена значений величины новыми (в случае пересечения столбцов)
            );

//Проверяем результат
assert_checkequal(type(cDatas),1);//Проверяем тип данных
assert_checktrue(abs(cDatas - eDatas) < 1E-12);
assert_checkequal(cDatasHeaders,eDatasHeaders);

//Проверяем конкатенацию данных с приведением типов к строке

//Приводим данные к строке
sDatas = string(Datas);
sAddingDatas = string(AddingDatas);
seDatas = string(eDatas);

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas(sDatas,..//Данные (исходные, к которым добавляем данные)
            AddingDatas,..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c",..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            %t..//Замена значений величины новыми (в случае пересечения столбцов)
            );

//Проверяем результат
assert_checkequal(type(cDatas),10);//Проверяем тип данных
assert_checkequal(cDatas,seDatas);
assert_checkequal(cDatasHeaders,eDatasHeaders);

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas(Datas,..//Данные (исходные, к которым добавляем данные)
            sAddingDatas,..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c",..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            %t..//Замена значений величины новыми (в случае пересечения столбцов)
            );

//Проверяем результат
assert_checkequal(type(cDatas),10);//Проверяем тип данных
assert_checkequal(cDatas,seDatas);
assert_checkequal(cDatasHeaders,eDatasHeaders);

//Проверяем конкатенацию с пустым множеством

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas([],..//Данные (исходные, к которым добавляем данные)
            AddingDatas,..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c",..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            %t..//Замена значений величины новыми (в случае пересечения столбцов)
            );

//Проверяем результат
assert_checkequal(type(cDatas),1);//Проверяем тип данных
assert_checktrue(abs(cDatas - AddingDatas) < 1E-12);
assert_checkequal(cDatasHeaders,AddingDatasHeaders);

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas([],..//Данные (исходные, к которым добавляем данные)
            AddingDatas,..//Добавляем данные
            [],..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c",..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            %t..//Замена значений величины новыми (в случае пересечения столбцов)
            );

//Проверяем результат
assert_checkequal(type(cDatas),1);//Проверяем тип данных
assert_checktrue(abs(cDatas - AddingDatas) < 1E-12);
assert_checkequal(cDatasHeaders,AddingDatasHeaders);

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas(Datas,..//Данные (исходные, к которым добавляем данные)
            [],..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            AddingDatasHeaders,..//Заголовки добавляемых данных
            "c",..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            %t..//Замена значений величины новыми (в случае пересечения столбцов)
            );

//Проверяем результат
assert_checkequal(type(cDatas),1);//Проверяем тип данных
assert_checktrue(abs(cDatas - Datas) < 1E-12);
assert_checkequal(cDatasHeaders,DatasHeaders);

//Вызываем функцию
[cDatas,..//Данные после добавления данных
 cDatasHeaders..//Заголовки данных после добавления
 ]=AddDatas(Datas,..//Данные (исходные, к которым добавляем данные)
            [],..//Добавляем данные
            DatasHeaders,..//Заголовки данных, к которым добавляем данные
            [],..//Заголовки добавляемых данных
            "c",..//Направление конкатенации ('r' - новые ряды, 'с' - новые колонки)
            %t..//Замена значений величины новыми (в случае пересечения столбцов)
            );

//Проверяем результат
assert_checkequal(type(cDatas),1);//Проверяем тип данных
assert_checktrue(abs(cDatas - Datas) < 1E-12);
assert_checkequal(cDatasHeaders,DatasHeaders);

clear;
