[a,path] = libraryinfo('io_data_integrationlib');
clear a;
path = part(path,1:(length(path) - length('macros'))) + 'testCSV' + filesep();//Путь к csv-файлам

//Данные для тестирования
DatasHeaders = ['Ad1','Bw1','Ar2','C3','Yew2','A2','A3','C1','Cc5'];//Заголовки данных
Datas = rand(51, 9);//Данные
CSVFileName = path + 'rdatas2.csv';
datasCSV = [DatasHeaders;string(Datas)];//Данные в формате CSV

//Сохраняем данные в формате csv в файл
write_csv(datasCSV,CSVFileName);

//Запускаем функцию
[datas,..//Данные
 datasHeaders..//Заголовки данных
 ]=CSVFromFileToDatas(%t,..//Заголовки входных данных
                      CSVFileName..//Имя csv-файла
                      );

//Проверяем полученный результат
assert_checktrue(abs(datas - Datas) < 1E-7);
assert_checkequal(DatasHeaders,datasHeaders);

clear;
