//Данные для тестирования
DatasHeaders = ['Q1','P1','Q2','Q3','P2','Q4','P5'];//Заголовки данных
Datas = rand(27, 7);//Данные
isVectorized = %t;//Все функции векторизованы

//Функции для тестирования
function [y]=Fun(x)
    y = 0.3*x.^2 + 5.1*x + 6.1*sin(x) - 1.5;
endfunction
argumentsNames = ['P1','Q3'];

//Тестовый результат
eRezults = Fun(Datas(:,[2, 4]));

//Запускаем функцию
Rezults = CountFunction(Datas,..//Входные данные
                        DatasHeaders,..//Заголовки входных данных
                        Fun,..//Функция
                        argumentsNames,..//Имена (индексы) аргументов
                        isVectorized..//Векторизованы ли функции
                        );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

//Запускаем функцию
Rezults = CountFunction(Datas,..//Входные данные
                        DatasHeaders,..//Заголовки входных данных
                        'Fun',..//Функция
                        argumentsNames,..//Имена (индексы) аргументов
                        isVectorized..//Векторизованы ли функции
                        );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

//Запускаем функцию
Rezults = CountFunction(Datas,..//Входные данные
                        DatasHeaders,..//Заголовки входных данных
                        Fun,..//Функция
                        argumentsNames..//Имена (индексы) аргументов
                        );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

//Запускаем функцию
Rezults = CountFunction(Datas,..//Входные данные
                        DatasHeaders,..//Заголовки входных данных
                        'Fun',..//Функция
                        argumentsNames..//Имена (индексы) аргументов
                        );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

clear;
