//Данные для тестирования
DatasHeaders = ['Ad1','Bw1','Ar2','C3','Yew2','A2','A3','C1','Cc5'];//Заголовки данных
Datas = rand(51, 9);//Данные
isVectorized = %f;//Все функции векторизованы

//Функции для тестирования
function [y]=FunP(x,a,b,c,d)
    function y=F1(t)//Функция правой части
        y = tan(t) + t - a*x(1)^2 - c*x(2)^2;
    endfunction
    function y=F2(t)//Функция правой части
        y = t^3 + t - b*x(1)^2 - d*x(2)^2;
    endfunction
    y = [fsolve(0.0,F1),fsolve(0.0,F2)];
endfunction
Fun = list(FunP,0.141,0.27,1.35,2.79);
argumentsNames = ['Cc5','C1'];

//Тестовый результат
eRezults = [];
for ind=1:51
    eRezults = [eRezults;FunP(Datas(ind,[9, 8]),0.141,0.27,1.35,2.79)];
end

//Запускаем функцию
Rezults = CountFunction(Datas,..//Входные данные
                        DatasHeaders,..//Заголовки входных данных
                        Fun,..//Функция
                        argumentsNames,..//Имена (индексы) аргументов
                        isVectorized..//Векторизованы ли функции
                        );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

Fun = list('FunP',0.141,0.27,1.35,2.79);

//Запускаем функцию
Rezults = CountFunction(Datas,..//Входные данные
                        DatasHeaders,..//Заголовки входных данных
                        Fun,..//Функция
                        argumentsNames,..//Имена (индексы) аргументов
                        isVectorized..//Векторизованы ли функции
                        );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

clear;
