//Данные для тестирования
Datas = rand(51, 9);//Данные
isVectorized = [%t,%f,%f,%t];//Все функции векторизованы

//Функции для тестирования
function [y]=Fun1(x)
    y = 0.9*x.^4 + 5.7*x.^2 + 6.1*log(abs(x) + 1.0);
endfunction
function [y]=Fun2(x)
    function y=F(t)//Функция правой части
        y = tan(t) + t - 5.1*x(2)^2 - 0.111*x(3)^2 - x(1);
    endfunction
    y = fsolve(0.0,F);
endfunction
function [y]=Fun3(x)
    function y=F1(t)//Функция правой части
        y = tan(t) + t - 8.1*x(1)^2 - 0.171*x(2)^2;
    endfunction
    function y=F2(t)//Функция правой части
        y = t^3 + t - 2.1*x(1)^2 - 0.471*x(2)^2;
    endfunction
    y = [fsolve(0.0,F1),fsolve(0.0,F2)];
endfunction
function [y]=Fun4(x,a,b)
    y = a*sum(x.^4)*x.^3 + b;
endfunction
Functions = cell(1, 4);//Список функций для тестирования
Functions{1} = Fun1;
Functions{2} = 'Fun2';
Functions{3} = Fun3;
Functions{4} = list(Fun4,6.03,5.13);
rezultsNames = cell(1, 4);
rezultsNames{1} = ['eAd1','eAr2','eYew2'];
rezultsNames{2} = ['eBw1'];
rezultsNames{3} = ['eCc5','eC1'];
rezultsNames{4} = ['eA2','eA3','eeYew2','eeBw1'];

//Тестовый результат
rFun2 = [];
rFun3 = [];
for ind=1:51
    rFun2 = [rFun2;Fun2(Datas(ind,:))];
    rFun3 = [rFun3;Fun3(Datas(ind,:))];
end
eRezults = [Fun1(Datas),..
            rFun2,rFun3,..
            Fun4(Datas,6.03,5.13)];
eRezultsHeaders = ['eAd1','eAr2','eYew2','eBw1','eCc5','eC1','eA2',..
                   'eA3','eeYew2','eeBw1'];

//Запускаем функцию
Rezults = CountRezults(Datas,..//Входные данные
                       [],..//Заголовки входных данных
                       Functions,..//Функции
                       [],..//Имена (индексы) аргументов
                       rezultsNames,..//Имена (индексы) результатов
                       isVectorized..//Векторизованы ли функции
                       );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

//Запускаем функцию
[Rezults,..
 RezultsHeaders] = CountRezults(Datas,..//Входные данные
                                [],..//Заголовки входных данных
                                Functions,..//Функции
                                [],..//Имена (индексы) аргументов
                                rezultsNames,..//Имена (индексы) результатов
                                isVectorized..//Векторизованы ли функции
                                );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);
assert_checkequal(RezultsHeaders,eRezultsHeaders);

//Запускаем функцию
Rezults = CountRezults(Datas,..//Входные данные
                       Functions,..//Функции
                       [],..//Имена (индексы) аргументов
                       rezultsNames,..//Имена (индексы) результатов
                       isVectorized..//Векторизованы ли функции
                       );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

//Запускаем функцию
[Rezults,..
 RezultsHeaders] = CountRezults(Datas,..//Входные данные
                                Functions,..//Функции
                                [],..//Имена (индексы) аргументов
                                rezultsNames,..//Имена (индексы) результатов
                                isVectorized..//Векторизованы ли функции
                                );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);
assert_checkequal(RezultsHeaders,eRezultsHeaders);

clear;
