//Данные для тестирования
DatasHeaders = ['Ad1','Bw1','Ar2','C3','Yew2','A2','A3','C1','Cc5'];//Заголовки данных
Datas = rand(51, 9);//Данные
isVectorized = %f;//Все функции векторизованы

//Функции для тестирования
function [y]=FunP(x,a,b)
    function y=F(t)//Функция правой части
        y = tan(t) + t - a*x(2)^2 - b*x(3)^2 - x(1);
    endfunction
    y = fsolve(0.0,F);
endfunction
Fun = list(FunP,0.39,3.3);

//Тестовый результат
eRezults = [];
for ind=1:51
    eRezults = [eRezults;FunP(Datas(ind,:),0.39,3.3)];
end

//Запускаем функцию
Rezults = CountRezults(Datas,..//Входные данные
                       DatasHeaders,..//Заголовки входных данных
                       Fun,..//Функции
                       [],..//Имена (индексы) аргументов
                       [],..//Имена (индексы) результатов
                       isVectorized..//Векторизованы ли функции
                       );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

//Запускаем функцию
[Rezults,..
 RezultsHeader] = CountRezults(Datas,..//Входные данные
                               DatasHeaders,..//Заголовки входных данных
                               Fun,..//Функции
                               [],..//Имена (индексы) аргументов
                               [],..//Имена (индексы) результатов
                               isVectorized..//Векторизованы ли функции
                               );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);
assert_checktrue(isempty(RezultsHeader));

clear;
