//Данные для тестирования
Datas = rand(21, 5);//Данные
isVectorized = [%t,%f,%t,%f,%f];

//Функции для тестирования
function [y]=Fun1(x)
    y = 0.33*x.^3 + 5.7*x.^2 + 6.1*exp(-abs(x));
endfunction
function [y]=Fun2(x)
    function y=F(t)//Функция правой части
        y = tan(t) + t - 5.43*x(2)^2 - 0.141*x(3)^2 - 1.5*x(1);
    endfunction
    y = fsolve(0.0,F);
endfunction
function [y]=Fun3(x,a,b)
    y = a*sum(x.^4)*x.^3 + b;
endfunction
function [y]=Fun4(x)
    function y=F1(t)//Функция правой части
        y = 0.15*tan(t) + t - 8.1*x(1)^2 - 0.171*x(2)^2;
    endfunction
    function y=F2(t)//Функция правой части
        y = 0.3*t^3 + t - 2.1*x(1)^2 - 0.471*x(2)^2;
    endfunction
    y = [fsolve(0.0,F1),fsolve(0.0,F2)];
endfunction
function [y]=Fun5(x,a)
    function y=F1(t)//Функция правой части
        y = a*tan(t) + t - 8.1*x(1)^2 - 0.171*x(2)^2;
    endfunction
    function y=F2(t)//Функция правой части
        y = 0.33*t^5 + t - 2.1*x(1)^2 - 0.471*x(2)^2;
    endfunction
    y = [fsolve(0.0,F1),fsolve(0.0,F2),2.1*x(1)^3 - 0.471*x(2)^4];
endfunction
Functions = cell(1, 5);//Список функций для тестирования
Functions{1} = 'Fun1';
Functions{2} = Fun2;
Functions{3} = list(Fun3,0.21,0.33);
Functions{4} = 'Fun4';
Functions{5} = list(Fun5,0.45);
argumentsNames = cell(1, 5);//Имена аргументов
argumentsNames{1} = [1, 4];
argumentsNames{2} = [2, 1, 5];
argumentsNames{3} = [3];
argumentsNames{4} = [4, 5];
argumentsNames{5} = [1, 3];

//Тестовый результат
rFun2 = [];
rFun4 = [];
rFun5 = [];
for ind=1:21
    rFun2 = [rFun2;Fun2(Datas(ind,[2, 1, 5]))];
    rFun4 = [rFun4;Fun4(Datas(ind,[4, 5]))];
    rFun5 = [rFun5;Fun5(Datas(ind,[1, 3]),0.45)];
end
eRezults = [Fun1(Datas(:,[1, 4])),rFun2,..
            Fun3(Datas(:,[3]),0.21,0.33),..
            rFun4,rFun5];

//Запускаем функцию
Rezults = CountRezults(Datas,..//Входные данные
                       [],..//Заголовки входных данных
                       Functions,..//Функции
                       argumentsNames,..//Имена (индексы) аргументов
                       [],..//Имена (индексы) результатов
                       isVectorized..//Векторизованы ли функции
                       );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

//Запускаем функцию
[Rezults,..
 RezultsHeader] = CountRezults(Datas,..//Входные данные
                               [],..//Заголовки входных данных
                               Functions,..//Функции
                               argumentsNames,..//Имена (индексы) аргументов
                               [],..//Имена (индексы) выходных значений функций
                               isVectorized..//Векторизованы ли функции
                               );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);
assert_checktrue(isempty(RezultsHeader));

//Запускаем функцию
Rezults = CountRezults(Datas,..//Входные данные
                       Functions,..//Функции
                       argumentsNames,..//Имена (индексы) аргументов
                       [],..//Имена (индексы) результатов
                       isVectorized..//Векторизованы ли функции
                       );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

//Запускаем функцию
[Rezults,..
 RezultsHeader] = CountRezults(Datas,..//Входные данные
                               Functions,..//Функции
                               argumentsNames,..//Имена (индексы) аргументов
                               [],..//Имена (индексы) выходных значений функций
                               isVectorized..//Векторизованы ли функции
                               );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);
assert_checktrue(isempty(RezultsHeader));

clear;
