//Данные для тестирования
DatasHeaders = ['Q1','P1','Q2','Q3','P2','Q4','P5'];//Заголовки данных
Datas = rand(27, 7);//Данные
isVectorized = %t;//Все функции векторизованы

//Функции для тестирования
function [y]=Fun1(x)
    y = 0.3*x.^2 + 5.1*x + 6.1*sin(x) - 1.5;
endfunction
function [y]=Fun2(x)
    y = 0.3*x.^3 + 5.1*x + 6.63*cos(x) - 1.83;
endfunction
function [y]=Fun3(x)
    y = -0.3*x.^5 + 5.1*x.^3 + 6.7*cos(x).^2 + 0.51;
endfunction
Functions = cell(1, 3);//Список функций для тестирования
Functions{1} = Fun1;
Functions{2} = 'Fun2';
Functions{3} = Fun3;
argumentsNames = cell(1, 3);//Имена аргументов
argumentsNames{1} = ['P1','Q3'];
argumentsNames{2} = ['Q1','Q2','Q4'];
argumentsNames{3} = ['P1','P2','P5','Q3'];
rezultsNames = cell(1, 3);
rezultsNames{1} = ['eP1','eQ3'];
rezultsNames{2} = ['eQ1','eQ2','eQ4'];
rezultsNames{3} = ['eP1w','eP2','eP5','eQ3w'];

//Тестовый результат
eRezults = [Fun1(Datas(:,[2, 4])),..
            Fun2(Datas(:,[1, 3, 6])),..
            Fun3(Datas(:,[2, 5, 7, 4]))];
eRezultsHeaders = ['eP1','eQ3','eQ1','eQ2','eQ4','eP1w','eP2','eP5','eQ3w'];

//Запускаем функцию
Rezults = CountRezults(Datas,..//Входные данные
                       DatasHeaders,..//Заголовки входных данных
                       Functions,..//Функции
                       argumentsNames,..//Имена (индексы) аргументов
                       rezultsNames,..//Имена (индексы) результатов
                       isVectorized..//Векторизованы ли функции
                       );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

//Запускаем функцию
[Rezults,..
 RezultsHeaders] = CountRezults(Datas,..//Входные данные
                                DatasHeaders,..//Заголовки входных данных
                                Functions,..//Функции
                                argumentsNames,..//Имена (индексы) аргументов
                                rezultsNames,..//Имена (индексы) результатов
                                isVectorized..//Векторизованы ли функции
                                );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);
assert_checkequal(RezultsHeaders,eRezultsHeaders);

//Запускаем функцию
Rezults = CountRezults(Datas,..//Входные данные
                       DatasHeaders,..//Заголовки входных данных
                       Functions,..//Функции
                       argumentsNames,..//Имена (индексы) аргументов
                       rezultsNames..//Имена (индексы) результатов
                       );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

//Запускаем функцию
[Rezults,..
 RezultsHeaders] = CountRezults(Datas,..//Входные данные
                                DatasHeaders,..//Заголовки входных данных
                                Functions,..//Функции
                                argumentsNames,..//Имена (индексы) аргументов
                                rezultsNames..//Имена (индексы) результатов
                                );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);
assert_checkequal(RezultsHeaders,eRezultsHeaders);

//Задаем функции в виде массива строк
Functions = ['Fun1','Fun2','Fun3'];

//Запускаем функцию
Rezults = CountRezults(Datas,..//Входные данные
                       DatasHeaders,..//Заголовки входных данных
                       Functions,..//Функции
                       argumentsNames,..//Имена (индексы) аргументов
                       rezultsNames,..//Имена (индексы) результатов
                       isVectorized..//Векторизованы ли функции
                       );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

//Запускаем функцию
[Rezults,..
 RezultsHeaders] = CountRezults(Datas,..//Входные данные
                                DatasHeaders,..//Заголовки входных данных
                                Functions,..//Функции
                                argumentsNames,..//Имена (индексы) аргументов
                                rezultsNames,..//Имена (индексы) результатов
                                isVectorized..//Векторизованы ли функции
                                );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);
assert_checkequal(RezultsHeaders,eRezultsHeaders);

//Запускаем функцию
Rezults = CountRezults(Datas,..//Входные данные
                       DatasHeaders,..//Заголовки входных данных
                       Functions,..//Функции
                       argumentsNames,..//Имена (индексы) аргументов
                       rezultsNames..//Имена (индексы) результатов
                       );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

//Запускаем функцию
[Rezults,..
 RezultsHeaders] = CountRezults(Datas,..//Входные данные
                                DatasHeaders,..//Заголовки входных данных
                                Functions,..//Функции
                                argumentsNames,..//Имена (индексы) аргументов
                                rezultsNames..//Имена (индексы) результатов
                                );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);
assert_checkequal(RezultsHeaders,eRezultsHeaders);

clear;
