//Данные для тестирования
DatasHeaders = ['Ad1','Bw1','Ar2','C3','Yew2','A2','A3','C1','Cc5'];//Заголовки данных
Datas = rand(51, 9);//Данные
isVectorized = [%t,%f,%f,%t];//Все функции векторизованы

//Функции для тестирования
function [y]=Fun1(x)
    y = 0.9*x.^4 + 5.7*x.^2 + 6.1*log(abs(x) + 1.0);
endfunction
function [y]=Fun2(x)
    function y=F(t)//Функция правой части
        y = tan(t) + t - 5.1*x(2)^2 - 0.111*x(3)^2 - x(1);
    endfunction
    y = fsolve(0.0,F);
endfunction
function [y]=Fun3(x)
    function y=F1(t)//Функция правой части
        y = tan(t) + t - 8.1*x(1)^2 - 0.171*x(2)^2;
    endfunction
    function y=F2(t)//Функция правой части
        y = t^3 + t - 2.1*x(1)^2 - 0.471*x(2)^2;
    endfunction
    y = [fsolve(0.0,F1),fsolve(0.0,F2)];
endfunction
function [y]=Fun4(x,a)
    y = a*sum(x.^4)*x.^3 + 3.51;
endfunction
Functions = cell(1, 4);//Список функций для тестирования
Functions{1} = Fun1;
Functions{2} = 'Fun2';
Functions{3} = Fun3;
Functions{4} = list(Fun4,5.1);
argumentsNames = cell(1, 4);//Имена аргументов
argumentsNames{1} = ['Ad1','Ar2','Yew2'];
argumentsNames{2} = ['Bw1','C3','A3'];
argumentsNames{3} = ['Cc5','C1'];
argumentsNames{4} = ['A2','A3','Yew2','Bw1'];
rezultsNames = cell(1, 4);
rezultsNames{1} = ['eAd1','eAr2','eYew2'];
rezultsNames{2} = ['eBw1'];
rezultsNames{3} = ['eCc5','eC1'];
rezultsNames{4} = ['eA2','eA3','eeYew2','eeBw1'];

//Тестовый результат
rFun2 = [];
rFun3 = [];
for ind=1:51
    rFun2 = [rFun2;Fun2(Datas(ind,[2, 4, 7]))];
    rFun3 = [rFun3;Fun3(Datas(ind,[9, 8]))];
end
eRezults = [Fun1(Datas(:,[1, 3, 5])),..
            rFun2,rFun3,..
            Fun4(Datas(:,[6, 7, 5, 2]),5.1)];
eRezultsHeaders = ['eAd1','eAr2','eYew2','eBw1','eCc5','eC1','eA2',..
                   'eA3','eeYew2','eeBw1'];

//Запускаем функцию
Rezults = CountRezults(Datas,..//Входные данные
                       DatasHeaders,..//Заголовки входных данных
                       Functions,..//Функции
                       argumentsNames,..//Имена (индексы) аргументов
                       rezultsNames,..//Имена (индексы) результатов
                       isVectorized..//Векторизованы ли функции
                       );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);

//Запускаем функцию
[Rezults,..
 RezultsHeaders] = CountRezults(Datas,..//Входные данные
                                DatasHeaders,..//Заголовки входных данных
                                Functions,..//Функции
                                argumentsNames,..//Имена (индексы) аргументов
                                rezultsNames,..//Имена (индексы) результатов
                                isVectorized..//Векторизованы ли функции
                                );

//Проверяем полученный результат
assert_checkequal(Rezults,eRezults);
assert_checkequal(RezultsHeaders,eRezultsHeaders);

clear;
