//Данные для тестирования
Datas = rand(27, 7);//Данные
isVectorized = %t;//Все функции векторизованы

//Функции для тестирования
function [y]=Fun1(x)
    y = 0.3*x.^2 + 5.1*x + 6.1*sin(x) - 1.5;
endfunction
function [y]=Fun2(x)
    y = 0.3*x.^3 + 5.1*x + 6.63*cos(x) - 1.83;
endfunction
function [y]=Fun3(x)
    y = -0.3*x.^5 + 5.1*x.^3 + 6.7*cos(x).^2 + 0.51;
endfunction
Functions = cell(1, 3);//Список функций для тестирования
Functions{1} = Fun1;
Functions{2} = Fun2;
Functions{3} = Fun3;
argumentsNames = cell(1, 3);//Имена аргументов
argumentsNames{1} = [2, 4];
argumentsNames{2} = [1, 3, 6];
argumentsNames{3} = [2, 5, 7, 4];
rezultsNames = cell(1, 3);
rezultsNames{1} = [2,8];
rezultsNames{2} = [1,4,3];
rezultsNames{3} = [7,5,6,9];

//Тестовый результат
eRezults = [Fun1(Datas(:,[2, 4])),..
            Fun2(Datas(:,[1, 3, 6])),..
            Fun3(Datas(:,[2, 5, 7, 4]))];
errRezults = rand(eRezults);//Ошибки
eeRezults = eRezults + errRezults;
eeeRezults = eeRezults(:,[3,1,5,4,7,8,6,2,9]);
eRezultsHeaders = [2,8,1,4,3,7,5,6,9];
errRezults = abs(errRezults);//Ошибки
merrRezults = mean(errRezults,'r');
maerrRezults = max(errRezults,'r');

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean,..//Среднее значение погрешности рассчитанных выходных данных
 сoutputDatasErrMax..//Максимальное значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     [],..//Заголовки выходных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMax - maerrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean,..//Среднее значение погрешности рассчитанных выходных данных
 сoutputDatasErrMax..//Максимальное значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     [],..//Заголовки выходных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames..//Имена (индексы) результатов
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMax - maerrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean..//Среднее значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     [],..//Заголовки выходных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean..//Среднее значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     [],..//Заголовки выходных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames..//Имена (индексы) результатов
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas..//Экспериментальные выходные данные (выделенные)
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     [],..//Заголовки выходных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas..//Экспериментальные выходные данные (выделенные)
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     [],..//Заголовки выходных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames..//Имена (индексы) результатов
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean,..//Среднее значение погрешности рассчитанных выходных данных
 сoutputDatasErrMax..//Максимальное значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMax - maerrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean,..//Среднее значение погрешности рассчитанных выходных данных
 сoutputDatasErrMax..//Максимальное значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames..//Имена (индексы) результатов
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMax - maerrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean..//Среднее значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean..//Среднее значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames..//Имена (индексы) результатов
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas..//Экспериментальные выходные данные (выделенные)
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas..//Экспериментальные выходные данные (выделенные)
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     [],..//Заголовки входных данных
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames..//Имена (индексы) результатов
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean,..//Среднее значение погрешности рассчитанных выходных данных
 сoutputDatasErrMax..//Максимальное значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMax - maerrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean,..//Среднее значение погрешности рассчитанных выходных данных
 сoutputDatasErrMax..//Максимальное значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames..//Имена (индексы) результатов
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMax - maerrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean..//Среднее значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas,..//Экспериментальные выходные данные (выделенные)
 сoutputDatasErrMean..//Среднее значение погрешности рассчитанных выходных данных
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames..//Имена (индексы) результатов
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErrMean - merrRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas..//Экспериментальные выходные данные (выделенные)
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames,..//Имена (индексы) результатов
                     isVectorized..//Векторизованы ли функции
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);

//Запускаем функцию
[сoutputDatasErr,..//Абсолютные погрешности выходных данных
 сoutputDatas,..//Рассчитанные выходные данные
 outputDatasHeaders,..//Заголовки рассчитанных выходных данных
 outputDatas..//Экспериментальные выходные данные (выделенные)
 ] = CountRezultsErr(Datas,..//Входные данные
                     eeeRezults,..//Выходные данные
                     Functions,..//Функции
                     argumentsNames,..//Имена (индексы) аргументов
                     rezultsNames..//Имена (индексы) результатов
                     );

//Проверяем полученный результат
assert_checktrue(abs(сoutputDatas - eRezults) < 1E-12);
assert_checktrue(abs(сoutputDatasErr - errRezults) < 1E-12);
assert_checkequal(outputDatasHeaders,eRezultsHeaders);
assert_checktrue(abs(outputDatas - eeRezults) < 1E-12);

clear;
