[a,path] = libraryinfo('io_data_integrationlib');
clear a;
path = part(path,1:(length(path) - length('macros'))) + 'testCSV' + filesep();//Путь к csv-файлам

//Данные для тестирования
DatasHeaders = ['C1','D1','C2','C3','D2','C4','C5'];//Заголовки данных
Datas = rand(21, 7);//Данные
CSVFileName = path + 'rwdatas10.csv';

//Запускаем функцию
datasCSV = DatasToCSVFile(Datas,..//Входные данные
                          DatasHeaders,..//Заголовки входных данных
                          %t,..//Перезаписываем в файл
                          CSVFileName,..//Имя файла данных
                          't',..//Разделитель
                          ','..//Десятичный разделитель
                          );

//Проверяем полученный результат
assert_checkequal(datasCSV,[DatasHeaders;strsubst(string(Datas),'.',',')]);

//Проверяем считанный из файла результат
datasCSV = read_csv(CSVFileName,'t');
assert_checkequal(datasCSV,[DatasHeaders;strsubst(string(Datas),'.',',')]);

//Дописываем данные в файл
aDatasHeaders = ['C1','C5','D1','C2','Y4','D2','C3','U6','C4'];//Заголовки данных
aDatas = rand(12, 9);//Данные

//Запускаем функцию
datasCSV = DatasToCSVFile(aDatas,..//Входные данные
                          aDatasHeaders,..//Заголовки входных данных
                          %f,..//Дозаписываем в файл
                          CSVFileName,..//Имя файла данных
                          't',..//Разделитель
                          ','..//Десятичный разделитель
                          );

//Проверяем полученный результат
aDatas = aDatas(:,[1,3,4,7,6,9,2]);
assert_checkequal(datasCSV,[DatasHeaders;strsubst(string([Datas;aDatas]),'.',',')]);

//Проверяем считанный из файла результат
datasCSV = read_csv(CSVFileName,'t');
assert_checkequal(datasCSV,[DatasHeaders;strsubst(string([Datas;aDatas]),'.',',')]);

clear;
