[a,path] = libraryinfo('io_data_integrationlib');
clear a;
path = part(path,1:(length(path) - length('macros'))) + 'testCSV' + filesep();//Путь к csv-файлам

//Данные для тестирования
Datas = rand(21, 5);//Данные
CSVFileName = path + 'rwdatas15.csv';

//Запускаем функцию
datasCSV = DatasToCSVFile(Datas,..//Входные данные
                          [],..//Пустые заголовки данных
                          %t,..//Перезаписываем файл
                          CSVFileName,..//Имя файла данных
                          'y',..//Разделитель
                          ','..//Десятичный разделитель
                          );

//Проверяем полученный результат
assert_checkequal(datasCSV,strsubst(string(Datas),'.',','));

//Проверяем считанный из файла результат
datasCSV = read_csv(CSVFileName,'y');
assert_checkequal(datasCSV,strsubst(string(Datas),'.',','));

//Данные для дозаписи
aDatasHeaders = [3, 5, 2, 1, 4];
aDatas = rand(24, 5);

//Запускаем функцию
datasCSV = DatasToCSVFile(aDatas,..//Входные данные
                          aDatasHeaders,..//Пустые заголовки данных
                          %f,..//Перезаписываем файл
                          CSVFileName,..//Имя файла данных
                          'y',..//Разделитель
                          ','..//Десятичный разделитель
                          );

//Проверяем полученный результат
aDatas = aDatas(:,[3, 5, 2, 1, 4]);
assert_checkequal(datasCSV,strsubst(string([Datas;aDatas]),'.',','));

//Проверяем считанный из файла результат
datasCSV = read_csv(CSVFileName,'y');
assert_checkequal(datasCSV,strsubst(string([Datas;aDatas]),'.',','));

clear;
